SystemOrganization addCategory: #'SqueakEnh-SqueakersInfo'!

!Browser methodsFor: '*squeakers-message functions' stamp: 'Samir Saidani 1/30/2004 03:02'!
shiftedMessageListMenu: aMenu 
	"Fill aMenu with the items appropriate when the shift key is held down"
	Smalltalk isMorphic
		ifTrue: [aMenu addStayUpItem].
	aMenu addList: #(#('method pane' #makeIsolatedCodePane) #('tile scriptor' #openSyntaxView) #('toggle diffing (D)' #toggleDiffing) #('implementors of sent messages' #browseAllMessages) #- #('local senders of...' #browseLocalSendersOfMessages) #('local implementors of...' #browseLocalImplementors) #- #('spawn sub-protocol' #spawnProtocol) #('spawn full protocol' #spawnFullProtocol) #- #('sample instance' #makeSampleInstance) #('inspect instances' #inspectInstances) #('inspect subinstances' #inspectSubInstances) ).
	self addExtraShiftedItemsTo: aMenu.
	aMenu addList: #(#- #('change category...' #changeCategory) ).
	self canShowMultipleMessageCategories
		ifTrue: [aMenu addList: #(#('show category (C)' #showHomeCategory) )].
	aMenu addList: #(#- #('change sets with this method' #findMethodInChangeSets) #('revert to previous version' #revertToPreviousVersion) #('remove from current change set' #removeFromCurrentChanges) #('revert & remove from changes' #revertAndForget) #('add to current change set' #adoptMessageInCurrentChangeset) #('copy up or copy down...' #copyUpOrCopyDown) #- #('fetch documentation' #fetchDocPane) #('info on author' #authorInfo) #('more...' #unshiftedYellowButtonActivity) ).
	^ aMenu! !

!StringHolder methodsFor: '*squeakers-message list menu' stamp: 'Samir Saidani 1/30/2004 03:09'!
authorInfo
	| class selector |
	(selector _ self selectedMessageName)
		ifNotNil: [class _ self selectedClassOrMetaClass.
			class
				ifNotNil: [Utilities identifyAuthorForClass: class selector: selector]]! !

!Utilities class methodsFor: '*squeakers-identification' stamp: 'sam 2/2/2004 15:52'!
identifyAuthorForClass: aClass selector: aSelector 
	| timeStamp smAccount |
	Transcript open.
	timeStamp _ Utilities
				timeStampForMethod: (aClass compiledMethodAt: aSelector).
	timeStamp isEmpty
		ifTrue: [Transcript show: 'Sorry, no available information'. ^self].
SMSqueakMap default accounts.
	smAccount _ SMSqueakMap default accountWithInitials: timeStamp substrings first.
	smAccount
		ifNil: [Transcript show: 'Sorry, no available information'.
			^ self].
	#(#name #summary #email #url )
		do: [:message | Transcript
				show: (smAccount perform: message);
				 cr]! !

PackageInfo subclass: #SqueakersInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakEnh-SqueakersInfo'!

!SqueakersInfo methodsFor: 'as yet unclassified' stamp: 'Samir Saidani 1/31/2004 15:06'!
readmeText
^ 'Add in the method menu of the browser the possibility to have more
info on the author : email, complete name, url, description... if such
informations are available on SqueakMap. So SqueakMap is a
prerequisite. Try it by open a method menu then more... then info on
author.'
! !

!SqueakersInfo methodsFor: 'as yet unclassified' stamp: 'Samir Saidani 1/30/2004 01:51'!
methodCategoryPrefix 
^ '*squeakers'! !
